var controledescripts = {
	iniciar: function () {
		this.iniciarItens();

		this.nomeP = window.arguments[0].nomePol;
		this.siteP = window.arguments[0].siteP;
		this.sites = new Array();

		if (window.arguments[0].sites)
			this.sites = window.arguments[0].sites.split(" ");

		document.title = this.stringset.getFormattedString("controledescripts.sitesTitle", [decodeURIComponent(this.nomeP)]);

		if (this.siteP)
			this.endereco.value = this.siteP;

		this.carregarSites();
		this.atualizarBotoes();
		this.endereco.focus();
	},

	adicionarSite: function (protPadrao) {
		var url = this.endereco.value.replace(/^\s+|\s+$/g,"");

		if (!protPadrao)
			protPadrao = "http://";

		if (!/^\w+:$/.test(url)) {
			if (/^\w+:\/+$/.test(url))
				url = url.replace(/\/+/, "");
			else {
				if (!/^\w+:/.test(url))
					url = protPadrao+url;

				try {
					var sES = Components.classes["@mozilla.org/network/io-service;1"]
					                    .getService(Components.interfaces.nsIIOService);
					var uri = sES.newURI(url, null, null);

					switch (uri.userPass || uri.scheme) {
						case "file": url = "file:"; break;
						default: url = uri.prePath;
					}
				}
				catch (erro) {
					var mensagem = null, titulo = null;
					var sPrompt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
					                        .getService(Components.interfaces.nsIPromptService);

					if (CdSUtil.fx()) {
						var stringset = document.getElementById("sites-strings-fx");
						mensagem = stringset.getString("invalidURI");
						titulo = stringset.getString("invalidURITitle");
					}
					else if (CdSUtil.sm()) {
						var stringset = document.getElementById("sites-strings-sm");
						mensagem = stringset.getFormattedString("alertInvalid", [url]);
						titulo = stringset.getString("alertInvalidTitle");
					}

					sPrompt.alert(window, titulo, mensagem);
					this.endereco.focus();
					return;
				}
			}
		}

		if (url && CdSUtil.obterPosicao(url, this.sites) < 0) {
			this.sites.push(url);
			this.sites = this.sites.sort();
			this.carregarSites();
		}

		this.endereco.value = "";
		this.atualizarBotoes();
		this.endereco.focus();
	},

	atualizarBotoes: function () {
		if (this.endereco.value)
			this.botaoAdicionar.disabled = false;
		else
			this.botaoAdicionar.disabled = true;

		if (this.lista.selectedItem)
			this.botaoExcluir.disabled = false;
		else
			this.botaoExcluir.disabled = true;

		this.botaoExcluirtd.disabled = CdSUtil.listaEstaVazia(this.sites);
	},

	carregarSites: function () {
		for (var i = this.lista.childNodes.length; i > 2; i--)
			this.lista.removeChild(this.lista.lastChild);

		for (i in this.sites)
			this.lista.appendItem(this.sites[i]);

		this.atualizarBotoes();
	},

	detectarTeclado: function (evento) {
		if (evento.target.id == "sites-endereco" && (evento.keyCode == 13 || evento.keyCode == 10))
			this.adicionarSite();
		else if (evento.target.id == "sites-lista" && evento.keyCode == 46)
			this.excluirSite();
	},

	excluirSite: function () {
		if (this.lista.selectedItem) {
			this.sites.splice(this.lista.selectedIndex, 1);
			this.carregarSites();
		}
	},

	excluirTd: function () {
		this.sites = new Array();
		this.carregarSites();
	},

	iniciarItens: function () {
		this.endereco = document.getElementById("sites-endereco");
		this.lista = document.getElementById("sites-lista");
		this.botaoAdicionar = document.getElementById("sites-adicionar");
		this.botaoExcluir = document.getElementById("sites-excluir");
		this.botaoExcluirtd = document.getElementById("sites-excluirtd");
		this.stringset = document.getElementById("sites-strings");
	},

	salvar: function () {
		if (this.siteP) {
			try {
				opener.CdSEditarSites(this.nomeP, true, this.sites.join(" "));
				return true;
			}
			catch (erro) {
				dump("** CdS error: couldn't find opener window script\n\n");
			}

			return false;
		
		}
		else {
			try {
				opener.CdS.editarSites(this.nomeP, true, this.sites.join(" "));
				return true;
			}
			catch (erro) {
				dump("** CdS error: couldn't find opener window script\n\n");
			}

			return false;
		}
	}
}
