var CdS = {
	iniciar: function () {
		this.iniciarItens();

		this.backup = new Array();
		this.politicas = new Array();
		this.modificadores = new Array();
		this.eventosValidos = new Array();

		if (CdSUtil.obterString("extensions.controledescripts.shortcut.modifiers"))
			this.modificadores = CdSUtil.obterString("extensions.controledescripts.shortcut.modifiers").split(/\s|,/);

		if (CdSUtil.obterString("dom.popup_allowed_events"))
			this.eventosValidos = CdSUtil.obterString("dom.popup_allowed_events").split(/\s/);

		this.tempoMaximo.value = CdSUtil.obterInteiro("dom.max_script_run_time");

		this.carregarCaixas();
		this.carregarAtalho();
		this.carregarEventos();
		this.carregarPoliticas();
		this.carregarMenuPoliticas();
	},

	adicionarEvento: function () {
		if (this.listaDisponiveis.selectedItem) {
			var evento = this.listaDisponiveis.selectedItem.label.toLowerCase();

			if (CdSUtil.obterPosicao(evento, this.eventosValidos) < 0) {
				this.eventosValidos.push(evento);
				this.eventosValidos.sort();
				this.carregarEventos();
			}
			else
				alert(this.stringset.getString("controledescripts.eventOnList"));
		}
	},

	adicionarPermissao: function (nomePol, permissao) {
		if (nomePol) {
			this.obterPolitica(nomePol).adicionarPermissao(permissao);
			this.carregarArvore(nomePol);
		}
		else
			openDialog("chrome://controledescripts/content/dialogs/permissao.xul",
			           "controledescripts-permissao", "chrome,centerscreen,modal",
			           {nomePol: this.menuPoliticas.value, edicao: false});
	},

	ajuda: function () {
		CdSUtil.abrirURL(document.getElementById("controledescripts-prefs").getAttribute("helpURL"));
	},

	atualizarAtalho: function () {
		this.modificador1.disabled =
		this.modificador2.disabled =
		this.tecla.disabled = !this.caixaAtivarAtalho.checked;
	},

	atualizarBotoesArvore: function () {
		this.botaoRenomear.disabled =
		this.botaoExcluir.disabled =
		this.botaoSites.disabled = this.menuPoliticas.value == "default";

		this.botaoEditar.disabled =
		this.botaoRemover.disabled = this.arvore.view.selection.currentIndex < 0;
	},

	atualizarBotoesEventos: function () {
		if (this.listaDisponiveis.selectedItem)
			this.botaoAdicionarEvento.disabled = false;
		else
			this.botaoAdicionarEvento.disabled = true;

		if (this.listaPermitidos.selectedItem)
			this.botaoRemoverEvento.disabled = false;
		else
			this.botaoRemoverEvento.disabled = true;
	},

	atualizarCaixa: function () {
		this.caixaIcones.disabled = !(this.caixaFerramentas.checked || this.caixaContexto.checked);
	},

	carregarArvore: function (nomePol) {
		this.arvore.view = new Arvore(this.obterPolitica(nomePol).permissoes);
		this.atualizarBotoesArvore();
	},

	carregarAtalho: function () {
		var tecla = new Array();
		tecla["accel"] = CdSUtil.mac() ? "Cmd" : "Ctrl";
		tecla["alt"] = CdSUtil.mac() ? "Opt" : "Alt";
		tecla["meta"] = "Meta";
		tecla["shift"] = "Shift";

		if (this.modificadores.length == 2) {
			this.modificador1.value = tecla[this.modificadores[0]];

			for (i in tecla)
				if (i != this.modificadores[0])
					this.modificador2.appendItem(tecla[i], i);

			this.modificador2.value = this.modificadores[1];
			this.tecla.insertItemAt(0, CdSUtil.obterString("extensions.controledescripts.shortcut.key"));
			this.tecla.selectedIndex = 0;

			this.atualizarAtalho();
		}
		else
			this.caixaEditarAtalho.hidden = true;
	},

	carregarCaixas: function () {
		var caixas   = document.getElementsByTagName("checkbox");
		var inversas = document.getElementsByAttribute("inverted", "true");

		for (var i = 0; i < caixas.length; i++)
			if (CdSUtil.obterPosicao(caixas[i], inversas) >= 0)
				caixas[i].checked = !CdSUtil.obterBooleana(caixas[i].getAttribute("preference"), true);
			else
				caixas[i].checked =  CdSUtil.obterBooleana(caixas[i].getAttribute("preference"), false);

		this.atualizarCaixa();
	},

	carregarEventos: function () {
		for (var i = this.listaPermitidos.childNodes.length; i > 2; i--)
			this.listaPermitidos.removeChild(this.listaPermitidos.lastChild);

		for (i in this.eventosValidos)
			this.listaPermitidos.appendItem(this.eventosValidos[i]);

		this.atualizarBotoesEventos();
	},

	carregarMenuPoliticas: function (nomePol) {
		if (!nomePol) nomePol = "default";
		var posicao = CdSUtil.obterPosicaoPol(nomePol, this.politicas);

		for (var i = this.popupPoliticas.childNodes.length; i > 2; i--)
			this.popupPoliticas.removeChild(this.popupPoliticas.lastChild);

		if (!CdSUtil.listaEstaVazia(this.politicas)) {
			this.separador.hidden = false;

			for (i in this.politicas) {
				var menuitem = document.createElement("menuitem");
				menuitem.setAttribute("label", decodeURIComponent(this.politicas[i].nome));
				menuitem.setAttribute("value", this.politicas[i].nome);
				menuitem.setAttribute("oncommand", "CdS.carregarArvore(\""+this.politicas[i].nome+"\");");
				this.popupPoliticas.appendChild(menuitem);
			}
		}
		else
			this.separador.hidden = true;

		if (posicao >= 0)
			this.menuPoliticas.selectedIndex = posicao + 2;
		else
			this.menuPoliticas.selectedIndex = 0;

		this.carregarArvore(nomePol);
	},

	carregarPoliticas: function () {
		var nomes = new Array();
		var branch = null, prefs = null;

		var politica  = new Politica("default");
		var politica2 = new Politica("default");

		branch = CdSUtil.sPreferencias.getBranch("capability.policy.default.");
		prefs = branch.getChildList("", {});

		for (i in prefs)
			if (CdSUtil.existePreferencia("capability.policy.default."+prefs[i])) {
				politica.adicionarPermissao({propriedade: prefs[i], status: CdSUtil.obterString("capability.policy.default."+prefs[i])});
				politica2.adicionarPermissao({propriedade: prefs[i], status: CdSUtil.obterString("capability.policy.default."+prefs[i])});
			}

		this.def = politica;
		this.defBackup = politica2;

		if (CdSUtil.existePreferencia("capability.policy.policynames") && CdSUtil.obterString("capability.policy.policynames"))
			nomes = CdSUtil.obterString("capability.policy.policynames").split(/\s|,/);

		for (i in nomes) {
			var pol = new Politica(nomes[i], CdSUtil.obterString("capability.policy."+nomes[i]+".sites"));
			var pol2 = new Politica(nomes[i], CdSUtil.obterString("capability.policy."+nomes[i]+".sites"));
			branch = CdSUtil.sPreferencias.getBranch("capability.policy."+nomes[i]+".");
			prefs = branch.getChildList("", {});
			
			for (j in prefs)
				if (prefs[j] != "sites")
					try {
						pol.adicionarPermissao({propriedade: prefs[j], status: branch["getCharPref"](prefs[j])});
						pol2.adicionarPermissao({propriedade: prefs[j], status: branch["getCharPref"](prefs[j])});
					} catch(erro) {
					}

			this.politicas.push(pol);
			this.backup.push(pol2);
		}

		this.politicas.sort(this.ordenador);
		this.backup.sort(this.ordenador);
	},

	criarPolitica: function (nome) {
		if (nome) {
			this.politicas.push(new Politica(nome));
			this.politicas.sort(this.ordenador);
			this.carregarMenuPoliticas(nome);
		}
		else
			openDialog("chrome://controledescripts/content/dialogs/politica.xul",
			           "controledescripts-politica", "chrome,centerscreen,modal",
			           {lista: this.politicas, renomear: null});
	},

	detectarTeclado: function (evento) {
		if (evento.keyCode == 46)
			switch (evento.target.id) {
				case "popups-permitidos": this.removerEvento(); break;
				case "avancado-arvore":   this.removerPermissao();
			}
	},

	editarPermissao: function (nomePol, permissao) {
		var indiceAtual = this.arvore.view.selection.currentIndex;

		if (nomePol) {
			this.obterPolitica(nomePol).editarPermissao(indiceAtual, permissao);
			this.carregarArvore(nomePol);
		}
		else {
			var polAtual = this.menuPoliticas.value;
			openDialog("chrome://controledescripts/content/dialogs/permissao.xul",
			           "controledescripts-permissao", "chrome,centerscreen,modal",
			           {nomePol: polAtual, edicao: this.obterPolitica(polAtual).permissoes[indiceAtual]});
		}
	},

	editarSites: function (nomePol, salvar, sites) {
		if (salvar)
			this.obterPolitica(nomePol).sites = sites;
		else {
			var polAtual = this.menuPoliticas.value;
			openDialog("chrome://controledescripts/content/dialogs/sites.xul",
			           "controledescripts-sites", "chrome,centerscreen",
			           {nomePol: polAtual, sites: this.obterPolitica(polAtual).sites, siteP: null});
		}
	},

	excluirPolitica: function () {
		if (confirm(this.stringset.getString("controledescripts.deletePolicy"))) {
			this.politicas.splice(CdSUtil.obterPosicaoPol(this.menuPoliticas.value, this.politicas), 1);
			this.carregarMenuPoliticas();
		}
	},

	iniciarItens: function () {
		this.stringset = document.getElementById("prefs-strings");
		this.tabbox = document.getElementById("prefs-tabbox");
		this.botaoAdicionarEvento = document.getElementById("popups-adicionar");
		this.botaoRemoverEvento = document.getElementById("popups-remover");
		this.listaDisponiveis = document.getElementById("popups-disponiveis");
		this.listaPermitidos = document.getElementById("popups-permitidos");
		this.arvore = document.getElementById("avancado-arvore");
		this.menuPoliticas = document.getElementById("avancado-politicas");
		this.popupPoliticas = document.getElementById("avancado-politicas-popup");
		this.separador = document.getElementById("avancado-separador");
		this.botaoRenomear = document.getElementById("avancado-renomear");
		this.botaoExcluir = document.getElementById("avancado-excluir");
		this.botaoEditar = document.getElementById("avancado-editar");
		this.botaoRemover = document.getElementById("avancado-remover");
		this.botaoSites = document.getElementById("avancado-sites");
		this.tempoMaximo = document.getElementById("outros-tempomaximo");
		this.caixaAtivarAtalho = document.getElementById("interface-ativaratalho");
		this.caixaContexto = document.getElementById("interface-exibircontexto");
		this.caixaEditarAtalho = document.getElementById("interface-editaratalho");
		this.caixaFerramentas = document.getElementById("interface-exibirmenu");
		this.caixaIcones = document.getElementById("interface-exibiricones");
		this.modificador1 = document.getElementById("interface-modificador1");
		this.modificador2 = document.getElementById("interface-modificador2");
		this.tecla = document.getElementById("interface-tecla");
	},

	obterPolitica: function (nomePol) {
		return (nomePol == "default") ? this.def : this.politicas[CdSUtil.obterPosicaoPol(nomePol, this.politicas)];
	},

	ordenador: function (a, b) {
		if (a.nome > b.nome)
			return 1;
		else if (a.nome < b.nome)
			return -1;
		else
			return 0;
	},

	removerEvento: function () {
		if (this.listaPermitidos.selectedItem) {
			this.eventosValidos.splice(this.listaPermitidos.selectedIndex, 1);
			this.carregarEventos();
		}
	},

	removerPermissao: function () {
		var polAtual = this.menuPoliticas.value;

		if (confirm(this.stringset.getString("controledescripts.deletePermission"))) {
			this.obterPolitica(polAtual).removerPermissao(this.arvore.view.selection.currentIndex);
			this.carregarArvore(polAtual);
		}
	},

	renomearPolitica: function (nomeNovo) {
		var nomeAtual = this.menuPoliticas.value;

		if (nomeNovo) {
			this.obterPolitica(nomeAtual).renomear(nomeNovo);
			this.politicas.sort(this.ordenador);
			this.carregarMenuPoliticas(nomeNovo);
		}
		else
			openDialog("chrome://controledescripts/content/dialogs/politica.xul",
			           "controledescripts-politica", "chrome,centerscreen,modal",
			           {lista: this.politicas, renomear: nomeAtual});
	},

	salvar: function () {
		if (this.tempoValido()) {
			this.salvarCaixas();
			this.salvarPoliticas();

			CdSUtil.salvarString("dom.popup_allowed_events", this.eventosValidos.join(" "));
			CdSUtil.salvarInteiro("dom.max_script_run_time", this.tempoMaximo.value);

			if (this.modificadores.length == 2) {
				CdSUtil.salvarString("extensions.controledescripts.shortcut.modifiers", this.modificadores[0]+","+this.modificador2.value);
				CdSUtil.salvarString("extensions.controledescripts.shortcut.key", this.tecla.value);
			}

			return true;
		}

		return false;
	},

	salvarCaixas: function () {
		var caixas   = document.getElementsByTagName("checkbox");
		var inversas = document.getElementsByAttribute("inverted", "true");

		for (var i = 0; i < caixas.length; i++)
			if (CdSUtil.obterPosicao(caixas[i], inversas) >= 0)
				CdSUtil.salvarBooleana(caixas[i].getAttribute("preference"),!caixas[i].checked);
			else
				CdSUtil.salvarBooleana(caixas[i].getAttribute("preference"), caixas[i].checked);
	},

	salvarPoliticas: function () {
		var nomesPerm = new Array();
		var nomesPol = new Array();

		if (this.def != this.defBackup) {
			with (this.defBackup)
				for (i in permissoes)
					CdSUtil.limparPreferencia("capability.policy.default."+permissoes[i].propriedade);

			with (this.def)
				for (i in permissoes)
					if (CdSUtil.salvarString("capability.policy.default."+permissoes[i].propriedade, permissoes[i].status))
						nomesPerm.push(permissoes[i].propriedade);
		}

		if (this.politicas != this.backup) {
			for (i in this.backup)
				with (this.backup[i]) {
					for (j in permissoes)
						CdSUtil.limparPreferencia("capability.policy."+nome+"."+permissoes[j].propriedade);

					CdSUtil.limparPreferencia("capability.policy."+nome+".sites");
				}

			if (CdSUtil.existePreferencia("capability.policy.policynames"))
				CdSUtil.limparPreferencia("capability.policy.policynames");

			for (i in this.politicas) {
				nomesPerm = new Array();

				with (this.politicas[i]) {
					for (j in permissoes)
						if (CdSUtil.salvarString("capability.policy."+nome+"."+permissoes[j].propriedade, permissoes[j].status))
							nomesPerm.push(permissoes[j].propriedade);

					CdSUtil.salvarString("capability.policy."+nome+".sites", sites);
					nomesPol.push(nome);
				}
			}

			if (!CdSUtil.listaEstaVazia(this.politicas))
				CdSUtil.salvarString("capability.policy.policynames", nomesPol.join(" "));
		}
	},

	sobreEvento: function () {
		if (this.listaDisponiveis.selectedItem)
			openDialog("chrome://controledescripts/content/dialogs/evento.xul",
			           "controledescripts-sobre", "chrome,centerscreen,modal",
			           this.listaDisponiveis.selectedItem.label);
	},

	tempoValido: function () {
		var valor = this.tempoMaximo.value;

		if (!valor || !/^-?\d+$/.test(valor)) {
			this.tabbox.selectedIndex = 3;
			this.tempoMaximo.focus();

			if (valor)
				alert(this.stringset.getString("controledescripts.invalidTime"));
			else
				alert(this.stringset.getString("controledescripts.emptyTime"));

			return false;
		}

		return true;
	}
}
